﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class GiroBotones : MonoBehaviour
{
    private Transform[,] TilesMatriz;
    [SerializeField] private Transform[] Tiles;
    [SerializeField] private Transform[] Espacios;

    private int[,] MatrizCompleta;
    private int[,] Matriz;

    [HideInInspector] public bool BotonGiraDos = false;
    [HideInInspector] public bool BotonGiraTres = false;

    

    private void Start()
    {
        Matriz = new int[2, 2];
        MatrizCompleta = new int[2, 2];

        LlenarMatrizCompleta();
        LlenarMatriz();

        print("Posicion 1: " + Matriz[0, 0]);
        print("Posicion 2: " + Matriz[1, 0]);
        print("Posicion 3: " + Matriz[0, 1]);
        print("Posicion 4: " + Matriz[1, 1]);
    }

    private void Update()
    {
        VerificarBotonGirarDos();
        VerificarBotonGiraTres();
    }

    private void MoverPiezasDos()
    {

        for (int i = 1; i < Espacios.Length + 1; i++)
        {
            if (Matriz[0, 0] == i)
            {
                Tiles[i - 1].position = Espacios[0].position;
                print("Moviendo pieza a espacio 1: " + i);
            }
        }


        for (int i = 1; i < Espacios.Length + 1; i++)
        {
            if (Matriz[0, 1] == i)
            {
                Tiles[i - 1].position = Espacios[2].position;
                print("Moviendo pieza a espacio 3: " + i);
            }
        }

    }
    private void MoverPiezasTres()
    {

        for (int i = 1; i < Espacios.Length + 1; i++)
        {
            if (Matriz[1, 0] == i)
            {
                Tiles[i - 1].position = Espacios[1].position;
                print("Moviendo pieza a espacio 2: " + i);
            }
        }

        for (int i = 1; i < Espacios.Length + 1; i++)
        {
            if (Matriz[0, 1] == i)
            {
                Tiles[i - 1].position = Espacios[2].position;
                print("Moviendo pieza a espacio 3: " + i);
            }
        }

        for (int i = 1; i < Espacios.Length + 1; i++)
        {
            if (Matriz[1, 1] == i)
            {
                Tiles[i - 1].position = Espacios[3].position;
                print("Moviendo pieza a espacio 4: " + i);
            }
        }
    }


    private void VerificarBotonGirarDos()
    {
        if (BotonGiraDos)
        {
            int temporal;
            temporal = Matriz[0,0];
            Matriz[0, 0] = Matriz[0, 1];
            Matriz[0, 1] = temporal;

            print("Posicion 1: " + Matriz[0, 0]);
            print("Posicion 2: " + Matriz[1, 0]);
            print("Posicion 3: " + Matriz[0, 1]);
            print("Posicion 4: " + Matriz[1, 1]);

            MoverPiezasDos();
            BotonGiraDos = false;

            VerificarMatriz();
        }
    }
    private void VerificarBotonGiraTres()
    {
        if (BotonGiraTres)
        {
            int temporal; 
            temporal = Matriz[1, 0];
            Matriz[1, 0] = Matriz[0, 1];
            Matriz[0, 1] = Matriz[1, 1];
            Matriz[1, 1] = temporal;

            print("Posicion 1: " + Matriz[0, 0]);
            print("Posicion 2: " + Matriz[1, 0]);
            print("Posicion 3: " + Matriz[0, 1]);
            print("Posicion 4: " + Matriz[1, 1]);

            MoverPiezasTres();
            BotonGiraTres = false;
            VerificarMatriz();
        }
    }


    public void VerificarMatriz()
    {
        bool correcta = true;

        for(int i = 0; i < 2; i++)
        {
            for(int j = 0; j < 2; j++)
            {
                if(Matriz[i, j] != MatrizCompleta[i, j])
                {
                    correcta = false;
                }
            }
        }

        if (correcta)
        {
            //Ejecuta lo que debe pasar cuando gana
            GameManager.GetInstancia().IncrementarContador();
            GameManager.GetInstancia().ActivarAnimacionesVanish(1);
            AudioManager.instance.PlayClip("Complete", "Effects2");

            Invoke("Desactivar", 2f);
        }
    }
    private void LlenarMatriz()
    {
        Matriz[0, 0] = 3;
        Matriz[1, 0] = 1;
        Matriz[0, 1] = 2;
        Matriz[1, 1] = 4;
    }
    private void LlenarMatrizCompleta()
    {
        MatrizCompleta[0, 0] = 1;
        MatrizCompleta[1, 0] = 2;
        MatrizCompleta[0, 1] = 3;
        MatrizCompleta[1, 1] = 4;
    }

    private void Desactivar()
    {
        gameObject.SetActive(false);
    }

}
