﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class CameraMovement : MonoBehaviour
{

    [Header("Zoom")]
    [HideInInspector] public bool ZoomActivado = false;
    [SerializeField] [Range(6f, 30f)]
    private float CantidadZoom = 20f;
    private float ZoomNormal = 5f;

    [Header("Seguir Personaje")]
    [SerializeField] private Transform PlayerTransform;
    [SerializeField] private float velocidadCamara = 3f;
    [SerializeField] private float RangoVision = 10f;

    public PlayerMovement myMovement;

    public bool puedoMover = true;
    private void Update()
    {
        if (puedoMover)
        {
            VerificarZoom();
        }
        

        if (!ZoomActivado)
        {
            if (puedoMover)
            {
                VerificarCamara();
            }
            
        }
        
    }


    private void VerificarCamara()
    {
        Vector2 posicionJugador = PlayerTransform.position;
        Vector2 posicionCamara = transform.position;

        bool movimientoEjecutado = false;
        
        if (posicionJugador.x > posicionCamara.x + RangoVision || posicionJugador.x < posicionCamara.x - RangoVision)
        {
            if (!movimientoEjecutado)
            {
                Invoke("MoverCamara", 1f);
                movimientoEjecutado = true;
            }
            
        }

        if (posicionJugador.y > posicionCamara.y + RangoVision || posicionJugador.y < posicionCamara.y - RangoVision)
        {
            if (!movimientoEjecutado)
            {
                Invoke("MoverCamara", 1f);
                movimientoEjecutado = true;
            }
        }


    }

    private void MoverCamara()
    {
        transform.position = Vector3.Lerp(transform.position, new Vector3(PlayerTransform.position.x, PlayerTransform.position.y, transform.position.z), velocidadCamara * Time.deltaTime);

        if(Vector2.Distance(transform.position, PlayerTransform.position) < 0.3f)
        {
            transform.position = new Vector3(PlayerTransform.position.x, PlayerTransform.position.y, transform.position.z);
        }
    }

    private void VerificarZoom()
    {
        //Zoom
        if (Input.GetButtonDown("Jump"))
        {
            if (!ZoomActivado)
            {
                Zoom(true);
                ZoomActivado = true;
            }
            else
            {
                Zoom(false);
                ZoomActivado = false;
            }

        }
    }

    private void Zoom(bool activar)
    {
        if (activar)
        {
            Camera.main.orthographicSize = CantidadZoom;
            transform.position = Vector2.zero;
            myMovement.PuedeMoverse = false;
            myMovement.PuedeSaltar = false;
        }
        else
        {
            Camera.main.orthographicSize = ZoomNormal;
            transform.position = new Vector2(PlayerTransform.position.x, PlayerTransform.position.y);
            myMovement.PuedeMoverse = true;
            myMovement.PuedeSaltar = true;
        }
        
    }
}
