﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.SceneManagement;

public class GameManager : MonoBehaviour
{
    private static GameManager instancia;
    public static GameManager GetInstancia()
    {
        return instancia;
    }

    private void Awake()
    {
        if (instancia == null)
        {
            instancia = this;
        }

        if (instancia != this)
        {
            Destroy(gameObject);
        }
    }

    private int ContadorJuegos = 0;

    public GameObject CaminoTutorial;

    public Animator vanish1;
    public Animator vanish2;
    public Animator vanish3;
    public Animator vanish4;

    public Camera mainCamera;
    public PlayerMovement myPlayerMovement;
    public Animator fondoNegro;
    public GameObject audioSource1;


    private void Start()
    {
        AudioManager.instance.PlayClip("8bitsSong", "AudioManager");
        CaminoTutorial.SetActive(true);
    }

    
    public void IncrementarContador()
    {
        ContadorJuegos++;
        Debug.Log("se incrementa el contador " + ContadorJuegos);

        if(ContadorJuegos > 3)
        {
            mainCamera.GetComponent<CameraMovement>().puedoMover = false;
            Invoke("AlejarCamara", 5f);
            //Ganas juego
        }
    }

    private void AlejarCamara()
    {
        audioSource1.SetActive(false);
        myPlayerMovement.PuedeMoverse = false;
        myPlayerMovement.PuedeSaltar = false;
        mainCamera.orthographicSize = 25f;
        mainCamera.transform.position = Vector2.zero;
        Invoke("AnimacionFondo", 2f);

    }

    private void AnimacionFondo()
    {
        mainCamera.transform.position = Vector2.zero;
        fondoNegro.SetBool("Final", true);
        Invoke("CambiarEscena", 3f);
    }

    public void DesactivarCamino()
    {
        CaminoTutorial.SetActive(false);
    }

    public void CambiarEscena()
    {
        SceneManager.LoadScene(1);
    }



    public void ActivarAnimacionesVanish(int cuadrante)
    {
        if(cuadrante == 1)
        {
            vanish1.SetBool("vanish1", true);
        }
        else if(cuadrante == 2)
        {
            vanish2.SetBool("vanish2", true);
        }
        else if(cuadrante  == 3)
        {
            vanish3.SetBool("vanish3", true);
        }
        else if(cuadrante == 4)
        {
            vanish4.SetBool("vanish4", true);
        }
    }




}
