﻿using System;
using UnityEngine;
using UnityEngine.Audio;

public class AudioManager : MonoBehaviour
{
    [Header("Audio Sources")]
    public AudioSource[] sources;

    [Header("Sonidos")]
    public Sound[] sounds;

    public static AudioManager instance;


    public void Awake()
    {
        if(instance == null)
        {
            instance = this;
        }
        else
        {
            Destroy(gameObject);
        }

        DontDestroyOnLoad(gameObject);

    }

    public void PlayClip(string nombre, string source)
    {
        Sound sonido = Array.Find(sounds, sound => sound.Nombre == nombre);

        if (sonido == null)
        {
            Debug.LogWarning("Sonido " + name + " no encontrado.");
            return;
        }

        for (int i = 0; i < sources.Length; i++)
        {
            if(sources[i].name == source)
            {
                AudioSource mySource = sources[i];
                mySource.volume = sonido.Volumen;
                mySource.loop = sonido.Loop;
                mySource.clip = sonido.Clip;
                mySource.Play();
            }
         
        }
    }

}
