﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class PlayerMovement : MonoBehaviour
{
    [SerializeField] private float velocidadMovimiento;

    private SpriteRenderer myRenderer;

    private Animator myAnimator;

    public bool PuedeMoverse =false;
    public bool PuedeSaltar = false;

    private bool Walking;
    private bool Jumping;
    private bool Up;
    private bool Down;
    private bool Side;

    private void Start()
    {
        myRenderer = GetComponent<SpriteRenderer>();
        myAnimator = GetComponent<Animator>();

    }

    private void Update()
    {
        if (PuedeMoverse)
        {
            Movimiento();
        }

        if (PuedeSaltar)
        {
            Saltar();

        }
    }


    private void Movimiento()
    {
        float movX = Input.GetAxis("Horizontal") * velocidadMovimiento * Time.deltaTime;
        float movY = Input.GetAxis("Vertical") * velocidadMovimiento * Time.deltaTime;

        Vector2 movimiento = new Vector2(transform.position.x + movX , transform.position.y + movY);

        transform.position = movimiento;

        if(movX > 0)
        {
            myRenderer.flipX = false;
            Side = true;
            Up = false;
            Down = false;
            Walking = true;
        }

        else if(movX < 0)
        {
            myRenderer.flipX = true;
            Side = true;
            Up = false;
            Down = false;
            Walking = true;
        }


        else if (movY > 0)
        {
            Up = true;
            Down = false;
            Side = false;
            Walking = true;
        }

        else if (movY < 0)
        {
            Down = true;
            Up = false;
            Side = false;
            Walking = true;
        }

        else if (movX == 0 && movY == 0)
        {
            Walking = false;
        }

        if(!Walking)
        {
            AudioManager.instance.PlayClip("Walking", "Effects1");
        }

        myAnimator.SetBool("Walk", Walking);
        myAnimator.SetBool("Up", Up);
        myAnimator.SetBool("Down", Down);
        myAnimator.SetBool("Side", Side);
    }


    private void Saltar()
    {
        if (Input.GetButtonDown("Fire1"))
        {
            PuedeMoverse = false;
            //Ejecuta la animacion de salto
            myAnimator.SetTrigger("Jump");
            AudioManager.instance.PlayClip("Jump", "Effects1");
            Debug.Log("Estoy Saltando");
        }
    }

    private void ActivarMovimiento()
    {
        PuedeMoverse = true;
        PuedeSaltar = true;
    }
}

