﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Bloque : MonoBehaviour
{
    [SerializeField] private Sprite[] sprites;

    private float velocidad = 0.5f;
    private float currentTime;
    private int contador;
    private SpriteRenderer myRenderer;

    private bool enElBloque = false;
    private bool cambiando = true;

    [HideInInspector]
    public bool activado = false;
    private void Start()
    {
        currentTime = 0;
        contador = 0;
        myRenderer = GetComponent<SpriteRenderer>();
    }
    private void Update()
    {
        if (cambiando)
        {
            CambiarSprites();
        }
        

        if (enElBloque)
        {
            if (Input.GetButtonDown("Fire1"))
            {
                if(contador == 1)
                {
                    cambiando = false;
                    activado = true;
                    GetComponentInParent<GiroTiles>().Verificar();
                }
            }
        }
    }


    private void CambiarSprites()
    {
        currentTime += Time.deltaTime;

        if(currentTime > velocidad)
        {
            if(contador < sprites.Length)
            {
                myRenderer.sprite = sprites[contador];
                contador++;
            }
            else
            {
                contador = 0;
            }

            currentTime = 0;
        }
    }

    private void OnTriggerStay2D(Collider2D collision)
    {
        if (collision.tag.Equals("Player"))
        {
            enElBloque = true;
        }
    }

    private void OnTriggerExit2D(Collider2D collision)
    {
        enElBloque = false;
    }


}
